Imports System.Runtime.InteropServices
Imports AddinExpress.OL
Imports Outlook = Microsoft.Office.Interop.Outlook
Imports System.Reflection

Public Class ADXOlForm1
    Public folder As Outlook.MAPIFolder = Nothing

    Public Sub New()
        MyBase.New()

        InitializeComponent()
    End Sub

    Private Sub ADXOlForm1_ADXAfterFormHide(sender As System.Object, e As AddinExpress.OL.ADXOlForm.ADXAfterFormHideEventArgs) Handles MyBase.ADXAfterFormHide
        If folder IsNot Nothing Then
            Marshal.ReleaseComObject(folder)
        End If
    End Sub

    Private Sub checkBoxAddRecipient_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles checkBoxAddRecipient.CheckedChanged
        textBoxAddRecipient.Enabled = checkBoxAddRecipient.Checked
    End Sub

    Private Sub checkBoxAddTextBody_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles checkBoxAddTextBody.CheckedChanged
        textBoxAddTextBody.Enabled = checkBoxAddTextBody.Checked
    End Sub

    Private Sub checkBoxAddAttachment_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles checkBoxAddAttachment.CheckedChanged
        textBoxAddAttachment.Enabled = checkBoxAddAttachment.Checked
        button1.Enabled = checkBoxAddAttachment.Checked
    End Sub

    Private Sub checkBoxSaveMailItemFolder_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles checkBoxSaveMailItemFolder.CheckedChanged
        textBoxSaveMailItemFolder.Enabled = checkBoxSaveMailItemFolder.Checked
        button2.Enabled = checkBoxSaveMailItemFolder.Checked
    End Sub

    Private Sub checkBoxSaveMailItemFile_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles checkBoxSaveMailItemFile.CheckedChanged
        textBoxSaveMailItemFile.Enabled = checkBoxSaveMailItemFile.Checked
        button3.Enabled = checkBoxSaveMailItemFile.Checked
    End Sub

    Private Function getFullFolderName(ByVal folder As Object) As String
        Dim _folder As Object = Nothing
        Dim folderObj As Object = Nothing
        Dim ifolder As New IntPtr()
        Dim fullName As String = [String].Empty, tmp As String
        Dim folderGuid As New Guid("00063006-0000-0000-C000-000000000046")

        Dim unk As IntPtr = Marshal.GetIUnknownForObject(folder)
        If unk = IntPtr.Zero Then
            Return [String].Empty
        End If
        Try
            folderObj = Marshal.GetObjectForIUnknown(unk)
            _folder = folderObj
            Marshal.QueryInterface(unk, folderGuid, ifolder)
            Marshal.Release(unk)
            While ifolder <> IntPtr.Zero
                Marshal.Release(ifolder)
                ifolder = IntPtr.Zero
                tmp = Convert.ToString(folderObj.[GetType]().InvokeMember("Name", BindingFlags.GetProperty, Nothing, folderObj, Nothing))
                fullName = ("\" & tmp) + fullName
                Try
                    _folder = folderObj.[GetType]().InvokeMember("Parent", BindingFlags.GetProperty, Nothing, folderObj, Nothing)
                Catch
                    _folder = Nothing
                Finally
                    Marshal.ReleaseComObject(folderObj)
                    folderObj = Nothing
                End Try
                If _folder IsNot Nothing Then
                    unk = Marshal.GetIUnknownForObject(_folder)
                    Marshal.QueryInterface(unk, folderGuid, ifolder)
                    Marshal.Release(unk)
                    folderObj = _folder
                End If
            End While
        Finally
            If folderObj IsNot Nothing Then
                Marshal.ReleaseComObject(folderObj)
            End If
        End Try
        Return "\" & fullName
    End Function
End Class
